function render_editor(id, config) {
  if ($("#"+id).val() != null) {

    var Dom = YAHOO.util.Dom,
    Event = YAHOO.util.Event;

    var newToolbar = new yui_editor_toolbar;
    var myConfig = {
      height: config.height,
      width: config.width,
      dompath: config.dom,
      animate: true,
      //handleSubmit: true,
      markup: config.markup,
      toolbar: newToolbar.toolbar
    };
    myConfig.toolbar.titlebar = config.title;
    myConfig.toolbar.collapse = config.collapse;
    myConfig.toolbar.draggable = config.draggable;
    myConfig.toolbar.buttonType = config.buttonType;

    $(document).ready(function() {
      $(".grippie").hide();
      $(".teaser-checkbox").hide();
      YAHOO.util.Dom.setStyle('toggleEditor-'+id, 'margin-top', '1.7em');
    });

    var myEditor = new YAHOO.widget.Editor(id, myConfig);
    if (! config.titlebar) {
      myEditor._defaultToolbar.titlebar = config.titlebar;
    }

    myEditor.render();

    // JCD: Eventually we probably should just move all of the config functionality into separate functions/files

    if (config.imgUpload == 1) {
      yui_img_uploader(myEditor, '?q=/yui_editor/image_upload', 'files[upload]', config.base_path);
	}

    if (config.resize == 1) {
      myEditor.on('editorContentLoaded', function() {
        resize = new YAHOO.util.Resize(myEditor.get('element_cont').get('element'), {
          handles: ['br'],
          autoRatio: true,
          status: true,
          proxy: true
        });
        resize.on('startResize', function() {
          this.hide();
          this.set('disabled', true);
        }, myEditor, true);
        resize.on('resize', function(args) {
          var h = args.height;
          var th = (this.toolbar.get('element').clientHeight + 2); //It has a 1px border..
          var dh = (this.dompath.clientHeight + 1); //It has a 1px top border..
          var newH = (h - th - dh);
          this.set('width', args.width + 'px');
          this.set('height', newH + 'px');
          this.set('disabled', false);
          this.show();
        }, myEditor, true);
      });
    }

    var plaintextState = 'off';
    if (config.plaintext == 1) {

      $("#"+id).after("<button id=\"toggleEditor-"+id+"\">"+ Drupal.t('Switch to Plain Editor') +"</button>");
      var _button = new YAHOO.widget.Button('toggleEditor-'+id);
      _button.addClass('toggleEditor');

      _button.on('click', function(ev) {
        Event.stopEvent(ev);
        if (plaintextState == 'off') {
          plaintextState = 'on';
          myEditor.saveHTML();
          Dom.setStyle(myEditor.get('element_cont').get('firstChild'), 'position', 'absolute');
          Dom.setStyle(myEditor.get('element_cont').get('firstChild'), 'top', '-9999px');
          Dom.setStyle(myEditor.get('element_cont').get('firstChild'), 'left', '-9999px');
          myEditor.get('element_cont').removeClass('yui-editor-container');
          Dom.setStyle(myEditor.get('element'), 'visibility', 'visible');
          Dom.setStyle(myEditor.get('element'), 'top', '');
          Dom.setStyle(myEditor.get('element'), 'left', '');
          Dom.setStyle(myEditor.get('element'), 'position', 'static');
          _button.set("label", Drupal.t('Switch to Rich Text Editor'));
          $(".grippie").show();
          $(".teaser-checkbox").show();
        }
        else {
          plaintextState = 'off';
          Dom.setStyle(myEditor.get('element_cont').get('firstChild'), 'position', 'static');
          Dom.setStyle(myEditor.get('element_cont').get('firstChild'), 'top', '0');
          Dom.setStyle(myEditor.get('element_cont').get('firstChild'), 'left', '0');
          Dom.setStyle(myEditor.get('element'), 'visibility', 'hidden');
          Dom.setStyle(myEditor.get('element'), 'top', '-9999px');
          Dom.setStyle(myEditor.get('element'), 'left', '-9999px');
          Dom.setStyle(myEditor.get('element'), 'position', 'absolute');
          myEditor.get('element_cont').addClass('yui-editor-container');
          myEditor._setDesignMode('on');
          myEditor.setEditorHTML(myEditor.get('textarea').value);
          _button.set("label", Drupal.t('Switch to Plain Editor'));
          $(".grippie").hide();
          $(".teaser-checkbox").hide();
        }
      });
    }

    var coderState = 'off';
    if (config.coder == 1) {

      myEditor.on('toolbarLoaded', function() {
        var codeConfig = {
          type: 'push', label: 'Edit HTML Code', value: 'editcode'
        };
        this.toolbar.addButtonToGroup(codeConfig, 'insertitem');

        this.toolbar.on('editcodeClick', function() {
          var ta = this.get('element'),
            iframe = this.get('iframe').get('element');

          if (coderState == 'on') {
            coderState = 'off';
            this.toolbar.set('disabled', false);
            this.setEditorHTML(ta.value);
            if (!this.browser.ie) {
              this._setDesignMode('on');
            }

            Dom.removeClass(iframe, 'editor-hidden');
            Dom.addClass(ta, 'editor-hidden');
            this.show();
            this._focusWindow();
          }
          else {
            coderState = 'on';
            this.cleanHTML();
            Dom.addClass(iframe, 'editor-hidden');
            Dom.removeClass(ta, 'editor-hidden');
            this.toolbar.set('disabled', true);
            this.toolbar.getButtonByValue('editcode').set('disabled', false);
            this.toolbar.selectButton('editcode');
            this.dompath.innerHTML = 'Editing HTML Code';
            this.hide();
          }

          return false;
        }, this, true);

        this.on('cleanHTML', function(ev) {
          this.get('element').value = ev.html;
        }, this, true);
        
        this.on('afterRender', function() {
          var wrapper = this.get('editor_wrapper');
          wrapper.appendChild(this.get('element'));
          this.setStyle('width', '100%');
          this.setStyle('height', '100%');
          this.setStyle('visibility', '');
          this.setStyle('top', '');
          this.setStyle('left', '');
          this.setStyle('position', '');

          this.addClass('editor-hidden');
        }, this, true);
      }, myEditor, true);
    }

    var toggle = 'off';
    $('#toggleEditor-'+id).bind('click', function () { toggle = 'on'; });
    $('form').bind('submit', function (e) {
      if (toggle == 'on') { 
        toggle = 'off';
        return false;
      }
      else if (plaintextState == 'on' || coderState == 'on') {
        myEditor.setEditorHTML(myEditor.get('textarea').value);
      }
      else {
        myEditor.saveHTML();
      }
    });

    if (config.flickr == 1) {
      var gutter = null;
      myEditor.on('toolbarLoaded', function() {
        gutter = new YAHOO.gutter();
        var flickrConfig = {
          type: 'push',
          label: 'Insert Flickr Image',
          value: 'flickr'
        }

        myEditor.toolbar.addButtonToGroup(flickrConfig, 'insertitem');

        myEditor.toolbar.on('flickrClick', function(ev) {
          myEditor._focusWindow();
          if (ev && ev.img) {
            var html = '<a href="' + ev.url + '"><img src="' + ev.img + '" title="' + ev.title + '"></a>';
            myEditor.execCommand('inserthtml', html);
          }

          gutter.toggle();
        });
        gutter.createGutter();
      });

      YAHOO.util.Event.onAvailable('flickr_search', function() {
        YAHOO.util.Event.on('flickr_results', 'click', function(ev) {
          var tar = YAHOO.util.Event.getTarget(ev);
          if (tar.tagName.toLowerCase() == 'img') {
            if (tar.getAttribute('fullimage', 2)) {
              var img = tar.getAttribute('fullimage', 2),
                  title = tar.getAttribute('fulltitle'),
                  owner = tar.getAttribute('fullowner'),
                  url = tar.getAttribute('fullurl');
              myEditor.toolbar.fireEvent('flickrClick', {
                type: 'flickrClick',
                img: img,
                title: title,
                owner: owner, 
                url: url
              });
            }
          }
        });

        oACDS = new YAHOO.widget.DS_XHR("",
          ["photo", "title", "id", "owner", "secret", "server"]);
        oACDS.scriptQueryParam = "tags";
        oACDS.responseType = YAHOO.widget.DS_XHR.TYPE_XML;
        oACDS.maxCacheEntries = 0;
        oACDS.scriptQueryAppend = "q=yui_editor/flickr";

        oAutoComp = new YAHOO.widget.AutoComplete('flickr_search','flickr_results', oACDS);
        oAutoComp.autoHighlight = false;
        oAutoComp.alwaysShowContainer = true;     
        oAutoComp.formatResult = function(oResultItem, sQuery) {
          var sTitle = oResultItem[0];
          var sId = oResultItem[1];
          var sOwner = oResultItem[2];
          var sSecret = oResultItem[3];
          var sServer = oResultItem[4];
          var urlPart = 'http:/'+'/static.flickr.com/' + sServer + '/' + sId + '_' + sSecret;
          var sUrl = urlPart + '_s.jpg';
          var lUrl = urlPart + '_m.jpg';
          var fUrl = 'http:/'+'/www.flickr.com/photos/' + sOwner + '/' + sId;
          var sMarkup = '<img src="' + sUrl + '" fullimage="' + lUrl + '" fulltitle="' + sTitle + '" fullid="' +
            sOwner + '" fullurl="' + fUrl + '" class="yui-ac-flickrImg" title="Click to add this image to the editor"><br>';

          return (sMarkup);
        };
      });
    }

    (function() {
      var Dom = YAHOO.util.Dom,
          Event = YAHOO.util.Event;

      YAHOO.gutter = function() {
        return {
          status: false,
          gutter: null,
          createGutter: function() {
            this.gutter = new YAHOO.widget.Overlay('gutter1', {
              height: '425px',
              width: '300px',
              context: [
                myEditor.get('element'),
                'tl',
                'tr'
              ],
              position: 'absolute',
              visible: false
            });
            this.gutter.hideEvent.subscribe(function() {
              myEditor.toolbar.deselectButton('flickr');
              Dom.setStyle('gutter1', 'visibility', 'visible');                
              var anim = new YAHOO.util.Anim('gutter1', {
                width: {
                  from: 300,
                  to: 0
                },
                opacity: {
                  from: 1,
                  to: 0
                }
              }, 1);
              anim.onComplete.subscribe(function() {  
                Dom.setStyle('gutter1', 'visibility', 'hidden');
              });
              anim.animate();
            }, this, true);
            this.gutter.showEvent.subscribe(function() {
              myEditor.toolbar.selectButton('flickr');
              Dom.setStyle(this.gutter.element, 'width', '0px');
              var anim = new YAHOO.util.Anim('gutter1', {
                width: {
                  from: 0,
                  to: 300
                },
                opacity: {
                  from: 0,
                  to: 1
                }
              }, 1);
              anim.animate();
            }, this, true);

            var warn = '';
            if (myEditor.browser.webkit || myEditor.browser.opera) {
              warn = myEditor.STR_IMAGE_COPY;
            }
            this.gutter.setBody('<h2>Flickr Image Search</h2><label for="flikr_search">Tag:</label>' +
              '<input type="text" value="" id="flickr_search">&nbsp;<div id="flickr_results">' + 
              '<p>Enter flickr tags into the box above, separated by commas. Be patient.<p></div>' + warn);
              this.gutter.render(document.body);
            },
            open: function() {
              Dom.get('flickr_search').value = '';
              this.gutter.show();
              this.status = true;
            },
            close: function() {
              this.gutter.hide();
              this.status = false;
            },
            toggle: function() {
              if (this.status) {
                this.close();
              }
              else {
                this.open();
              }
            }
          }
        }
      })
    ();
  }
};

function yui_img_uploader(rte, upload_url, upload_image_name, base_path) {
  rte.addListener('toolbarLoaded', function() {
    rte.toolbar.addListener('insertimageClick', function(o) {
      try {
        var imgPanel = new YAHOO.util.Element('yui-editor-panel');
        imgPanel.on ('contentReady', function() {
          try {
            var Dom = YAHOO.util.Dom;
            var label = document.createElement('label');
            label.innerHTML = '<strong>Upload:</strong>' +
              '<input type="file" id="insertimage_upload" name="' + upload_image_name +
              '" size="10" style="width: 20%"/>' +
              '<a href="#"  id="insertimage_upload_btn" style="width: 20%; margin-left: 10em;">Upload Image</a>' +
              '</label>';

            var img_elem=Dom.get('insertimage_url');
            Dom.getAncestorByTagName(img_elem, 'form').encoding = 'multipart/form-data';
            Dom.insertAfter(label, img_elem.parentNode);
                                                    
            YAHOO.util.Event.on('insertimage_upload_btn', 'click', function(ev) {
              YAHOO.util.Event.stopEvent(ev); // no default click action
              YAHOO.util.Connect.setForm(img_elem.form, true, true);
              var c = YAHOO.util.Connect.asyncRequest('POST', upload_url, { upload:
			    function(r) {
                  try {
                    resp = r.responseText.replace( /<hints .*/i, '');
                    var o = eval('('+resp+')');
                    if (o.status == 'UPLOADED') {
                      Dom.get('insertimage_upload').value = '';
                      Dom.get('insertimage_url').value=base_path + o.image_url;
                      Dom.get('insertimage_url').focus();
                      Dom.get('insertimage_upload').focus();
                    }
                    else {
                      alert ("Upload Failed: " + o.status);
                    }
                  }
                  catch (eee) {
                    YAHOO.log(eee.message, 'error');
                  }
                }
              });

              return false;
            });
          }
          catch (ee) {
            YAHOO.log(ee.message, 'error');
          }
        });
      }
      catch (e) {
        YAHOO.log(e.message, 'error');
      }
    });
  });
}
